import java.io.File;

import javax.xml.transform.ErrorListener;
import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.stream.StreamSource;

import com.saxonica.config.EnterpriseConfiguration;
import com.saxonica.config.EnterpriseTransformerFactory;
import com.saxonica.config.ProfessionalConfiguration;
import com.saxonica.config.ProfessionalTransformerFactory;

import net.sf.saxon.Configuration;
import net.sf.saxon.trans.XPathException;


public class SaxonTest {

  public static void main(String[] args) throws TransformerException {
    try {
//      Configuration configuration = Configuration.readConfiguration(new StreamSource(new File("resources/saxonEEConfig.xml")));
//      EnterpriseTransformerFactory factory = new EnterpriseTransformerFactory((EnterpriseConfiguration) configuration);
      
      Configuration configuration = Configuration.readConfiguration(new StreamSource(new File("resources/saxonPEConfig.xml")));
      ProfessionalTransformerFactory factory = new ProfessionalTransformerFactory((ProfessionalConfiguration) configuration);
      factory.setErrorListener(new ErrorListener() {
        @Override
        public void warning(TransformerException exception) throws TransformerException {
          exception.printStackTrace(System.out);
        }
        @Override
        public void fatalError(TransformerException exception) throws TransformerException {
          exception.printStackTrace(System.out);
        }
        
        @Override
        public void error(TransformerException exception) throws TransformerException {
          exception.printStackTrace(System.out);
        }
      });
      factory.newTransformer(new StreamSource(new File("resources/test-xsl-validation.xsl")));
    } catch (TransformerConfigurationException e) {
      e.printStackTrace(System.out);
    } catch (XPathException e) {
      e.printStackTrace(System.out);
    }
  }
}
